package ch.zhaw.gartenverwaltung.backgroundtasks;

import ch.zhaw.gartenverwaltung.io.PlantList;
import ch.zhaw.gartenverwaltung.io.TaskList;
import ch.zhaw.gartenverwaltung.models.Garden;

import javax.mail.MessagingException;
import java.io.IOException;
import java.util.TimerTask;

public class BackgroundTasks extends TimerTask {
    private final TaskList taskList;
    private final Garden garden;
    private final PlantList plantList;
    private  final Notifier notifier;
    //TODO uncomment: privat final WeatherGardenTaskPlaner weatherGardenTaskPlaner;

    public BackgroundTasks(TaskList taskList, Garden garden, PlantList plantList) {
        this.taskList = taskList;
        this.garden = garden;
        this.plantList = plantList;
        notifier = new Notifier(taskList, garden, plantList);
        //TODO uncomment: weatherGardenTaskPlaner = new WeatherGardenTaskPlaner(taskList);
    }

    @Override
    public void run() {
        // TODO uncomment: weatherGardenTaskPlaner.refreshTasks();
        try {
            try {
                notifier.sendNotifications();
            } catch (MessagingException e) {
                e.printStackTrace();
                // TODO logger
            }
        } catch (IOException e) {
            e.printStackTrace();
            // TODO logger
        }
    }
}

